#line 1 "C:/Users/Admin/Downloads/ReadWrite RTC8583 time and display it on LCD/Soft/RTC_RW.c"
#line 24 "C:/Users/Admin/Downloads/ReadWrite RTC8583 time and display it on LCD/Soft/RTC_RW.c"
struct TTime
{
 char year, month, day, hours, minutes, seconds, mseconds;
} TimeRW;


sbit Soft_I2C_Scl at RB4_bit;
sbit Soft_I2C_Sda at RB5_bit;
sbit Soft_I2C_Scl_Direction at TRISB4_bit;
sbit Soft_I2C_Sda_Direction at TRISB5_bit;
#line 1 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
#line 64 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
char _RTC_year_, _RTC_month_, _RTC_day_, _RTC_hours_, _RTC_minutes_, _RTC_seconds_, _RTC_mseconds_;
#line 71 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
unsigned char RTC_Read_PCF8583(unsigned char addr)
{
 unsigned char value;

  Soft_I2C_Start() ;
  Soft_I2C_Write( 0xA0 ) ;
  Soft_I2C_Write(addr) ;
  Soft_I2C_Start() ;
  Soft_I2C_Write( 0xA0 ) ;

 value =  Soft_I2C_Read(0) ;
  Soft_I2C_Stop() ;

 return value;
}
#line 91 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
void RTC_Write_PCF8583(unsigned char addr, unsigned char value)
{
  Soft_I2C_Start() ;
  Soft_I2C_Write( 0xA0 ) ;
  Soft_I2C_Write(addr) ;
  Soft_I2C_Write(value) ;
  Soft_I2C_Stop() ;
}

void WriteTime(char year, char month, char day, char hours, char minutes, char seconds, char mseconds)
{
 _RTC_year_ = year, _RTC_month_ = month, _RTC_day_ = day;
 _RTC_hours_ = hours, _RTC_minutes_ = minutes, _RTC_seconds_ = seconds, _RTC_mseconds_ = mseconds;

  Soft_I2C_Start() ;
  Soft_I2C_Write( 0xA0 ) ;
  Soft_I2C_Write( 0x00 ) ;
  Soft_I2C_Write( 0x80 ) ;
  Soft_I2C_Write(mseconds) ;
  Soft_I2C_Write(((seconds/10)<<4) + (seconds%10)) ;
  Soft_I2C_Write(((minutes/10)<<4) + (minutes%10)) ;
  Soft_I2C_Write(((hours/10)<<4) + (hours%10)) ;
  Soft_I2C_Write(((year%4)<<6) + ((day/10)<<4) +(day%10)) ;
  Soft_I2C_Write(((month/10)<<4) + (month%10)) ;
  Soft_I2C_Stop() ;

 RTC_Write_PCF8583( 0x10 , year);
#line 124 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
 RTC_Write_PCF8583( 0x00 ,  0x00 );
#line 132 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
}

void ReadTime()
{
 char updateYear, yearmod4, byteRead;
 char year, month, day, hours, minutes, seconds, mseconds;

 updateYear = 0;

  Soft_I2C_Start() ;
  Soft_I2C_Write( 0xA0 ) ;
  Soft_I2C_Write( 0x01 ) ;
  Soft_I2C_Start() ;
  Soft_I2C_Write( 0xA1 ) ;

 byteRead =  Soft_I2C_Read(1) ;
 mseconds = (byteRead >> 4)*10 + (byteRead & 0x0F);

 byteRead =  Soft_I2C_Read(1) ;
 seconds = (byteRead >> 4)*10 + (byteRead & 0x0F);

 byteRead =  Soft_I2C_Read(1) ;
 minutes = (byteRead >> 4)*10 + (byteRead & 0x0F);

 byteRead =  Soft_I2C_Read(1) ;
 hours = (byteRead >> 4)*10 + (byteRead & 0x0F);

 byteRead =  Soft_I2C_Read(1) ;
 day = ((byteRead & 0b00110000) >> 4)*10 + (byteRead & 0x0F);
 yearmod4 = (byteRead & 0b11000000) >> 6;

 byteRead =  Soft_I2C_Read(0) ;
 month = ((byteRead & 0b00010000) >> 4)*10 + (byteRead & 0x0F);

  Soft_I2C_Stop() ;

  Soft_I2C_Start() ;
  Soft_I2C_Write( 0xA0 ) ;
  Soft_I2C_Write( 0x10 ) ;
  Soft_I2C_Start() ;
  Soft_I2C_Write( 0xA1 ) ;

 byteRead =  Soft_I2C_Read(0) ;
 if(yearmod4 != byteRead % 4 )
 {
 byteRead++;
 updateYear = 1;
 }
 year = byteRead;

  Soft_I2C_Stop() ;

 if(updateYear > 0)
 {
#line 192 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
 RTC_Write_PCF8583( 0x10 , year);
 }

 _RTC_year_ = year, _RTC_month_ = month, _RTC_day_ = day;
 _RTC_hours_ = hours, _RTC_minutes_ = minutes, _RTC_seconds_ = seconds, _RTC_mseconds_ = mseconds;
}
#line 201 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
void Clock_Out_RTC_1Hz()
{
#line 211 "c:/users/admin/downloads/readwrite rtc8583 time and display it on lcd/soft/.././lib/lib_rtc8583_mikroc.h"
 RTC_Write_PCF8583(0,0b00000001);
}
#line 40 "C:/Users/Admin/Downloads/ReadWrite RTC8583 time and display it on LCD/Soft/RTC_RW.c"
void UART1_jump_a_line()
{
 UART1_Write(10);
 UART1_Write(13);
}

char const weekday_names[7][10] =
{
 {"Sunday"},
 {"Monday"},
 {"Tuesday"},
 {"Wednesday"},
 {"Thursday"},
 {"Friday"},
 {"Saturday"}
};

void Display_Time()
{
 char txt[16], tmp;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);

 Lcd_Cmd(_LCD_FIRST_ROW);
 UART1_Write_Text("Time: ");


 txt[0] = (_RTC_day_ / 10) + 48;
 txt[1] = (_RTC_day_ % 10) + 48;
 txt[2] = '/';
 txt[3] = (_RTC_month_ / 10) + 48;
 txt[4] = (_RTC_month_ % 10) + 48;
 txt[5] = '/';
 txt[6] = '2';
 txt[7] = (_RTC_year_ / 100) + 48;
 txt[8] = ((_RTC_year_ % 100) / 10) + 48;
 txt[9] = (_RTC_year_ % 10) + 48;
 txt[10] = 0;

 for(tmp=0;tmp<10;tmp++)
 {
 UART1_Write(txt[tmp]);
 Lcd_Chr_CP(txt[tmp]);
 }

 UART1_Write_Text(" - ");
 Lcd_Cmd(_LCD_SECOND_ROW);

 txt[0] = (_RTC_hours_ / 10) + 48;
 txt[1] = (_RTC_hours_ % 10) + 48;
 txt[2] = ':';
 txt[3] = (_RTC_minutes_ / 10) + 48;
 txt[4] = (_RTC_minutes_ % 10) + 48;
 txt[5] = ':';
 txt[6] = (_RTC_seconds_ / 10) + 48;
 txt[7] = (_RTC_seconds_ % 10) + 48;
 txt[8] = '.';
 txt[9] = (_RTC_mseconds_ / 10) + 48;
 txt[10] = (_RTC_mseconds_ % 10) + 48;
 txt[11] = 's';
 txt[12] = 0;

 for(tmp=0;tmp<12;tmp++)
 {
 UART1_Write(txt[tmp]);
 Lcd_Chr_CP(txt[tmp]);
 }
 UART1_jump_a_line();
}


sbit LCD_RS at RD5_bit;
sbit LCD_EN at RD7_bit;

sbit LCD_D4 at RD0_bit;
sbit LCD_D5 at RD2_bit;
sbit LCD_D6 at RD4_bit;
sbit LCD_D7 at RD6_bit;

sbit LCD_RS_Direction at TRISD5_bit;
sbit LCD_EN_Direction at TRISD7_bit;

sbit LCD_D4_Direction at TRISD0_bit;
sbit LCD_D5_Direction at TRISD2_bit;
sbit LCD_D6_Direction at TRISD4_bit;
sbit LCD_D7_Direction at TRISD6_bit;



void MainInit()
{
 ANSEL = 0;
 ANSELH = 0;

 UART1_Init(9600);
 Lcd_Init();
 I2C1_Init(10000);

 UART1_Write_Text("Build : "  "19:58:41" );
 UART1_Write_Text(", "  "Apr 29 2018" );
 UART1_jump_a_line();
 Delay_ms(1000);

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_FIRST_ROW);
 Lcd_Out(1,1,"Date:   /  /");
 Lcd_Out(2,1,"Time:   :  :");

 Clock_Out_RTC_1Hz();

 TimeRW.year = 18;
 TimeRW.month = 12;
 TimeRW.day = 31;
 TimeRW.hours = 23;
 TimeRW.minutes = 59;
 TimeRW.seconds = 40;
 TimeRW.mseconds = 0;

 WriteTime(TimeRW.year, TimeRW.month,TimeRW.day, TimeRW.hours, TimeRW.minutes, TimeRW.seconds, TimeRW.mseconds);
}



void main()
{
 MainInit();

 while(1)
 {
 ReadTime();
 Display_Time();
 Delay_ms(500);
 }
}
